$regfile = "m8def.dat"                                      '  ATmega8
$crystal = 4000000                                          '    4 mHz
'$lib "lcd4.lbx"                                             ' 4-       



Dim Frequency As Long
Dim Flag As Bit
Dim Overflow As Byte
Dim Cnt As Long
' 
Dim W As Byte
Dim S As Word
Dim D As Word
Dim U As Word

Dim Byte0 As Byte
Dim Byte1 As Byte
Dim Signtemperatura As String * 1
Dim T1 As Byte
Dim T2 As Byte
Dim I As Integer

'******************************
Config Portd = Input
Config Timer0 = Timer , Prescale = 1                        ' CK=8MHz -  0
Config Timer1 = Counter , Edge = Rising , Noise Cancel = 1  '   
Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' 
Config Pind.6 = Input                                       '   6  D   -    
Config 1wire = Portc.4                                      '    Ds18b20     4 , 7   + 


Config Lcd = 16 * 2                                         '  16*2 (   HD44780)
Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Start Adc                                                   ' - 
Button Alias Pind.6                                         '   Button  6  D


'****Reset for Start***********
Stop Timer0
Stop Counter1

'******Interrupt routline setting****
On Timer0 Tm0_intsub
On Timer1 Tm1_intsub


'******Enable Interrupts, timer 0, counter1*****
Enable Interrupts
Enable Timer0
Counter1 = 0
Overflow = 0
Cnt = 31250
Flag = 0

'******Initial******
Cls                                                         '  
Lcd "      "
Wait 3

Locate 2 , 12                                               '  
Lcd " ********** "                                          ' 
Cursor Off
Wait 1
Locate 2 , 12                                               '  
 For U = 1 To 12
  Shiftlcd Right                                            ' right
  Wait 1                                                    'wait a moment
Next

 For U = 1 To 12

  Shiftlcd Left                                             ' left
  Wait 1                                                    'wait a moment

Next




Start Timer0
Start Counter1

'*******Main Loop*****
Main:
Do
    If Flag = 1 Then
            Frequency = Overflow * 65536
            Frequency = Frequency + Counter1
            Frequency = Frequency / 4
            Frequency = Frequency * 60
            Cls
            Cursor Off
            Lcd Frequency
            Lcd " Rot/MIN"
            Locate 1 , 1

Temperatura:
Config 1wire = Portc.4
            1wreset
            1wwrite &HCC                                    '    
            1wwrite &H44                                    ' 

            Waitms 750                                      '  

            1wreset
            1wwrite &HCC
            1wwrite &HBE                                    '   


            Byte0 = 1wread()                                '  

            Byte1 = 1wread()                                '  

            If Byte1 >= 248 Then                            '    .248    11111000  .       &HFF

         Byte0 = &HFF - Byte0
         Byte1 = &HFF - Byte1
         Signtemperatura = "-"

        Else
        Signtemperatura = "+"
        End If

           T1 = Byte0 / 16                                  '      4  (2*2*2*2=16)
           T2 = Byte1 * 16                                  '      4  (2*2*2*2=16)

           T1 = T1 + T2                                     '      .  LCD      
           Locate 2 , 1
           Lcd Signtemperatura ; T1 ; "C"

           Wait 2

            Gosub Key
Continue:

            Reset Flag
            Counter1 = 0
            Overflow = 0
            Cnt = 31250                                     '      1 
            Start Timer0
            Start Counter1
     End If
Loop

'************************************************
'*******Counter1 Overflow Interrupt**************
 Tm1_intsub:                                                ' counter1 -   
Incr Overflow
Return
'***********Timer0 Zero Interrupt****************
Tm0_intsub:
         If Cnt <> 0 Then                                   '   
                Decr Cnt
         Else
                Stop Counter1
                Stop Timer0
                Set Flag
         End If
Return
'************End of interrupt*********************

Key:

    If Button = 0 Then                                      '  -   2-       ...
    Goto Led                                                '    0      ( )
    Else                                                    '   ...
    Goto Continue                                           '    0      (  )
    End If                                                  ' 

Led:
        Start Adc                                           ' - 
            Cls
            W = Getadc(0)                                   '    0  .
            W = W / 58.2
            Locate 1 , 1                                    '  
            Lcd "" ; W ; "v"                        '    
            S = Getadc(1)
            S = S / 50                                      '    0  .
            Locate 2 , 1                                    '  
            Lcd "B=" ; S ; "L"
            D = Getadc(2)
            D = D / 50                                      '    0  .
            Locate 2 , 7                                    '  
            Lcd "G=" ; D ; "v"
            Waitms 100                                      '  0,1 

Return