$regfile = "m8def.dat"                                      '  ATmega8
$crystal = 8000000                                          '    8 mHz
'$lib "lcd4.lbx"                                             ' 4-       

$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space



'********* ******
Dim Frequency As Long
Dim Flag As Bit
Dim Overflow As Byte
Dim Cnt As Long
' 
Dim W As Byte
Dim S As Word
Dim D As Word
Dim U As Word

Dim Byte0 As Byte
Dim Byte1 As Byte
Dim Signtemperatura As String * 1
Dim Signtemperatura2 As String * 1
Dim T1 As Byte
Dim T2 As Byte
Dim T3 As Byte
Dim T4 As Byte
Dim I As Integer
Dim Button As Byte                                          'byte   0-255


'*********** *******************
Config Portd = Input
Config Timer0 = Timer , Prescale = 1                        ' CK=8MHz -  0
Config Timer1 = Counter , Edge = Rising , Noise Cancel = 1  '   
Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' 
Config Pind.6 = Input                                       '   6  D   -    
Config 1wire = Portc.4                                      '    Ds18b20 (1)     4 , 7   + 
Config 1wire = Portc.5                                      '    Ds18b20 (2)     4 , 7   + 
Config Pind.0 = Input
Config Debounce = 30                                        'config    30 mS

Config Lcd = 16 * 2                                         '  16*2 (   HD44780)
Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Start Adc                                                   ' - 
'Button Alias Pind.6                                         '   Button  6  D
'Button2 Alias Pind.7                                        '   Button2  7  D

'****Reset for Start***********
Stop Timer0
Stop Counter1

'******Interrupt routline setting****
On Timer0 Tm0_intsub
On Timer1 Tm1_intsub


'******Enable Interrupts, timer 0, counter1*****
Enable Interrupts
Enable Timer0
Counter1 = 0
Overflow = 0
Cnt = 31250
Flag = 0

'******Initial******
Deflcdchar 0 , 28 , 6 , 1 , 31 , 19 , 30 , 30 , 30          ' replace ? with number (0-7)
Deflcdchar 1 , 32 , 32 , 10 , 31 , 17 , 17 , 31 , 31        ' replace ? with number (0-7)

Cls                                                         '  
Cursor Off
Lcd "TAXOMETP v01"
Lowerline
  Lcd Chr(0)
'Lcd " xxxxxxxxxx "                                          ' 
Waitms 100

Locate 2 , 12                                               '  
  For U = 1 To 12
  Shiftlcd Right                                            ' right
  'Waitms 100                                                'wait a moment
Next

  For U = 1 To 12
  Shiftlcd Left                                             ' left
  'Waitms 100                                                'wait a moment
Next
Gosub Led
Wait 1
Cls
Button = 0

'*******Main Loop*****
Main:

Do
           Gosub Key                                        '  


 Loop


Continue:
    Start Timer0
    Start Counter1

    If Flag = 1 Then
            Frequency = Overflow * 65536
            Frequency = Frequency + Counter1
            Frequency = Frequency / 4
            Frequency = Frequency * 60
            Cls
            Cursor Off
            Lcd Frequency
            Lcd " OBOROTI"
            Locate 1 , 1

            Reset Flag
            Counter1 = 0
            Overflow = 0
            Cnt = 31250                                     '      1 
            Start Timer0
            Start Counter1
     End If

Temperatura:

Config 1wire = Portc.4
            1wreset
            1wwrite &HCC                                    '    
            1wwrite &H44                                    ' 

            Waitms 750                                      '  

            1wreset
            1wwrite &HCC
            1wwrite &HBE                                    '   


            Byte0 = 1wread()                                '  

            Byte1 = 1wread()                                '  

            If Byte1 >= 248 Then                            '    .248    11111000  .       &HFF

         Byte0 = &HFF - Byte0
         Byte1 = &HFF - Byte1
         Signtemperatura = "-"

        Else
        Signtemperatura = "+"
        End If

           T1 = Byte0 / 16                                  '      4  (2*2*2*2=16)
           T2 = Byte1 * 16                                  '      4  (2*2*2*2=16)

           T1 = T1 + T2                                     '      .  LCD      
           Locate 2 , 1
           Lcd Signtemperatura ; T1 ; "C"
           Waitms 100

Config 1wire = Portc.5
            1wreset
            1wwrite &HCC                                    '    
            1wwrite &H44                                    ' 

            Waitms 750                                      '  

            1wreset
            1wwrite &HCC
            1wwrite &HBE                                    '   


            Byte0 = 1wread()                                '  

            Byte1 = 1wread()                                '  

            If Byte1 >= 248 Then                            '    .248    11111000  .       &HFF

         Byte0 = &HFF - Byte0
         Byte1 = &HFF - Byte1
         Signtemperatura = "-"

        Else
        Signtemperatura2 = "+"
        End If

           T3 = Byte0 / 16                                  '      4  (2*2*2*2=16)
           T4 = Byte1 * 16                                  '      4  (2*2*2*2=16)

           T3 = T3 + T4                                     '      .  LCD      
           Locate 2 , 6
           Lcd Signtemperatura2 ; T1 ; "C"
           Waitms 100




'************************************************
'*******Counter1 Overflow Interrupt**************
 Tm1_intsub:                                                ' counter1 -   
Incr Overflow
Return
'***********Timer0 Zero Interrupt****************
Tm0_intsub:
         If Cnt <> 0 Then                                   '   
                Decr Cnt
         Else
                Stop Counter1
                Stop Timer0
                Set Flag
         End If
Return
'************End of interrupt*********************


'************  *********************
Key:

Stop Timer0
Stop Counter1

'Debounce Pind.6 , 1 , Pr '
Debounce Pind.6 , 0 , Pr , Sub

Debounce Pind.6 , 0 , Pr , Sub

'                       ^----- label to branch to
'                  ^---------- Branch when P6.0 goes low(0)
'            ^---------------- Examine P6.0
' Pind.6  low   Pr

'Debounce Pind.6 , 1 , Pr                                    'no branch

'Debounce Pind.6 , 1 , Pr                                    'will result in a return without gosub

End

Pr:

 Button = Button + 1
  If Button > 2 Then
  Reset Button
   Else

 End If

   If Button = 1 Then
   Gosub Led
   Else
   Gosub Led2
 End If


Return

'*****************************
'    If Button = 0 Then                                      '  -   2-       ...
 '   Gosub Led                                               '    0      ( )
  '  Else                                                    '   ...
   ' Goto Continue                                           '    0      (  )
'End If
 '   If Button2 = 0 Then                                     '  -   2-       ...
  '  Gosub Led2                                              '    0      ( )
   ' Else                                                    '   ...
    'Goto Continue                                           '    0      (  )

'End If                                                      ' 


'****************Led*****************************
Led:

  Portd.0 = 1
        Start Adc                                           ' - 
Deflcdchar 0 , 28 , 6 , 1 , 31 , 19 , 30 , 30 , 30          ' replace ? with number (0-7)
Deflcdchar 1 , 32 , 32 , 10 , 31 , 17 , 17 , 31 , 31        ' replace ? with number (0-7)

            Cls
            W = Getadc(0)                                   '    0  .
            W = W / 58.2
            Locate 1 , 1                                    '  
             'Lcd Chr(0) ; W ; ""
            Lcd "BEN" ; W ; ""                           '    
            S = Getadc(1)
            S = S / 50                                      '    0  .
            Locate 2 , 1                                    '  
             'Lcd Chr(1) ; S ; "V"
            Lcd "BAT=" ; S ; "V"
            D = Getadc(2)
            D = D / 50                                      '    0  .
            Locate 2 , 7                                    '  
            Lcd "G=" ; D ; "v"
            Waitms 500                                      '  0,1 
     Portd.0 = 0
Return
'****************Led2*****************************
Led2:
       Cls
           Lcd "NOW"                                        '    
           Lcd "G=" ; D ; "v"
           Waitms 500                                       '  0,1 

Return